require 'rake'
require 'rake/clean'
require 'rake/gempackagetask'
require 'rake/rdoctask'
require 'fileutils'
include FileUtils

NAME = 'g-gem'
VER = '0.1.0'
CLEAN.include ['**/.*.sw?', '*.gem', '.config']
RDOC_OPTS = []
spec = Gem::Specification.new do |s|
    s.name = NAME
    s.version = VER
    s.platform = Gem::Platform::RUBY
    s.has_rdoc = true
    s.extra_rdoc_files = ["README", "ChangeLog.git", "COPYING"]
    s.rdoc_options += RDOC_OPTS + ['--exclude', '^(examples|extras)\/', '--exclude', 'lib/camping.rb']
    s.summary = 'rubygems ebuild generator'
    s.description = s.summary
    s.author = 'Nguyễn Thái Ngọc Duy'
    s.email = 'pclouds@gentoo.org'
    s.homepage = 'http://dev.gentoo.org/~pclouds/g-gem'
    s.executables = ['g-gem']

    s.required_ruby_version = '>= 1.8.2'

    s.files = %w(COPYING README ChangeLog.git) +
      Dir.glob("{bin,doc/rdoc,test,lib,extras}/**/*") + 
      Dir.glob("ext/**/*.{h,c,rb}") +
      Dir.glob("examples/**/*.rb") +
      Dir.glob("tools/*.rb")
    
    s.require_path = "lib"
    s.bindir = "bin"
end

task :default => [:package]
task :package => ['ChangeLog.git', :clean]

Rake::GemPackageTask.new(spec) do |p|
    p.need_tar = true
    p.gem_spec = spec
end

task 'ChangeLog.git' do |t|
    f = File.open(t.name, 'w')
    f.write(%x(git log --no-color --stat))
    f.close
end
